local abs=math.abs
local reserved = {}
local tgt = 16

function check1(p,k)
   local s, count = 0,0
   for i=1,4 do 
      local t=get_tile(i,k)
      if t then s=s+t.label; count=count+1 end
   end
   return s, count
end

function check2(p,k)
   local s, count = 0,0
   for j=1,4 do 
      local t=get_tile(k,j)
      if t then s=s+t.label; count=count+1 end
   end
   return s, count
end

function legal(t,p)
   if math.floor(math.sqrt(tgt))^2==tgt then tgt=tgt+1 end
   if p.tile then return false end  
   local rtl = reserved[t.label]
   if rtl and rtl~=p.label then return false end
   if t.slot.row==nil then return check(t,p) end  
   if t.slot.row==p.row and abs(t.slot.col-p.col)==1 or
      t.slot.col==p.col and abs(t.slot.row-p.row)==1 
      then return check(t,p) end
   return false
end
  
function check(t,p) 
   if tgt%2 then for k=2,3 do reserved[tgt-k]='(4,'..k..')' end end
   local tr, tc = t.slot.row, t.slot.col
   local pr, pc = p.row, p.col
   local omit = tr==pr and (tc==pc-1 or tc==pc+1)
   if not omit then
      local s, count = check2(slot,pr)
      if count==3 then
         if s+t.label~=2*tgt then lost=true; return false 
         else 
            for j=1,4 do freeze(get_tile(pr,j)) end 
            freeze(t)
         end
      end
   end
   omit = tc==pc and (tr==pr-1 or tr==pr+1)
   if not omit then 
      local s, count = check1(slot,pc)
      if count==3 then
         if s+t.label~=2*tgt then lost=true; return false 
         else 
            for i=1,4 do freeze(get_tile(i,pc)) end 
            freeze(t)
         end
      end
   end
   return true  
end



